<?php
/*
S-GAE (Simple Graphical Accounting Engine) is a web application developed at /rdlab to 
graphically display the accounting information generated by our HPC queue manager.

Copyright (C) +2020  rdlab@cs.upc.edu - https://rdlab.cs.upc.edu

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

class configFile
{

    /**
     * Configuration file
     */
    function create_configuration($data)
    {
        foreach ($data as $key => $value) {
            $$key = $value;
        }

        $config = "<?php" . PHP_EOL;
        $config .= "/*" . PHP_EOL;
        $config .= "
S-GAE (Simple Graphical Accounting Engine) is a web application developed at /rdlab to 
graphically display the accounting information generated by our HPC queue manager.

Copyright (C) +2020  rdlab@cs.upc.edu - https://rdlab.cs.upc.edu

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
" . PHP_EOL . PHP_EOL;
        $config .= "======================================================================" . PHP_EOL;
        $config .= " Sgae3 configuration file" . PHP_EOL;
        $config .= "======================================================================" . PHP_EOL;
        $config .= "*/" . PHP_EOL . PHP_EOL;

        $config .= "// Application paths" . PHP_EOL;
        $config .= "\$app_path = \"$appPath\";" . PHP_EOL;

        $config .= "\$app_url = \"$appURL\"; // Avoid trailing slash" . PHP_EOL;
        $config .= "\$app_logfile = \"/tmp/sgae3.log\";" . PHP_EOL . PHP_EOL;

        $config .= "// Lool and feel" . PHP_EOL;
        $config .= "// Number of columns in charts grid" . PHP_EOL;
        $config .= "\$grid_columns = 3;" . PHP_EOL . PHP_EOL;

        $config .= "// Login Backend" . PHP_EOL;
        $config .= "// Default available values: \"htaccess\", \"localDB\"" . PHP_EOL;
        $config .= "\$login_backend = \"$loginBackend\";" . PHP_EOL . PHP_EOL;

        $config .= "// Database" . PHP_EOL;
        $config .= "\$db_host = \"$dbHost\";" . PHP_EOL;
        $config .= "\$db_port = \"$dbPort\";" . PHP_EOL;
        $config .= "\$db_user = \"$dbUser\";" . PHP_EOL;
        $config .= "\$db_name = \"$dbName\";" . PHP_EOL;
        $config .= "\$db_password = \"$dbPassword\";" . PHP_EOL . PHP_EOL;

        $config .= "// Slurm" . PHP_EOL;
        $config .= "\$sacct_path = \"$slurmBinPath/sacct\";" . PHP_EOL;
        $config .= "\$squeue_path = \"$slurmBinPath/squeue\";" . PHP_EOL;
        $config .= "\$lock_file = \"/dev/shm/sgae3.lck\";" . PHP_EOL;
        $config .= "\$output_file = \"/dev/shm/sgae3.tmp\";" . PHP_EOL . PHP_EOL;

        $config .= "// Date and time" . PHP_EOL;
        $config .= "date_default_timezone_set(\"Europe/Madrid\");" . PHP_EOL . PHP_EOL;
        $config .= "\$min_year = 2000;" . PHP_EOL . PHP_EOL;

        $config .= "?>" . PHP_EOL;
        return $config;
    }

    function save_configuration_to_file($config, $configFilePath)
    {
        if (!$config_file = fopen($configFilePath, "w")) {
            return false;
        }
        if (fwrite($config_file, $config) === FALSE) {
            return false;
        }
        return true;
    }
}
