<?php 
/*
S-GAE (Simple Graphical Accounting Engine) is a web application developed at /rdlab to 
graphically display the accounting information generated by our HPC queue manager.

Copyright (C) +2020  rdlab@cs.upc.edu - https://rdlab.cs.upc.edu

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

function get_app_url(){
    $url = isset($_SERVER['HTTPS']) ? 'https://' : 'http://';
    $url .= $_SERVER['SERVER_NAME'];
    $url .= htmlspecialchars($_SERVER['REQUEST_URI']);
    $app_url = dirname(dirname($url));
    return $app_url;
}

function check_config_exists($app_path){
  
    if (file_exists("$app_path/config/config.ini.php")) {
        $msg = "<h5>Developer mode</h5>sgae3 configuration file exists. Continuing with this process will overwrite its contents.<br>";
        $msg.= "Problems may also appear if database already exists";
        //TODO: INSTALLER OPEN FOR DEVEL
        //die("<div class=\"alert alert-danger\">sgae3 configuration file exists</div>");
    } else {
        $msg = "The sgae3 configuration file could not be found.";
    }
    
    return $msg;

}

function show_error($error)
{
    echo "<div class=\"alert alert-danger\">";
    echo "The following errors where found:<br>";
    echo "$error <br>";
    echo "Please fix these issues and run installation process again.";
    echo "</div>";
    die("<button type=\"button\" class=\"btn btn-primary\" onclick=\"window.history.back();\">Go Back</button>");
}

function show_warning($msg)
{
    echo "<div class=\"alert alert-warning\">";
    echo "The following issues where found:<br>";
    echo "$msg <br>";
    echo "Process continues omitting this step<br>";
    echo "</div>";
}

?>