<?php
/*
S-GAE (Simple Graphical Accounting Engine) is a web application developed at /rdlab to 
graphically display the accounting information generated by our HPC queue manager.

Copyright (C) +2020  rdlab@cs.upc.edu - https://rdlab.cs.upc.edu

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

namespace sgae3\Controller;

use Exception;

class ModulesController
{
    public function getModules(): array
    {
        $output = array();
        $modules_folder = $GLOBALS['app_path'] . "/modules";

        if(!is_dir($modules_folder))
        {
            return $output;
        }

        unset($output);
        unset($return_var);
        exec("ls $modules_folder", $output, $return_var);
        if ($return_var != 0) {
            trigger_error("Error browsing modules folder", E_USER_ERROR);
            throw new Exception("Exception: see log for details");
        }
        $modules = array();
        foreach ($output as $folder) {
            if(!$file = file_get_contents("$modules_folder/$folder/module.json")){
                continue;
            }
            $json = json_decode($file, true);
            $modules[$json['name']] = $json['label'];
        }

        return $modules;
    }

}
