<?php
/*
S-GAE (Simple Graphical Accounting Engine) is a web application developed at /rdlab to 
graphically display the accounting information generated by our HPC queue manager.

Copyright (C) +2020  rdlab@cs.upc.edu - https://rdlab.cs.upc.edu

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

namespace sgae3\Service;

interface LoginInterface
{

    /**
     * For external login systems (e.g .htaccess)
     *
     * @param string $username:
     *            username which is logged
     * @return: true if user is logged, false otherwise
     */
    public function isLogged(string $username): bool;

    /**
     * For user/password based login systems
     *
     * @param string $username:
     *            User to validate.
     * @param string $password:
     *            User's password.
     * @return: true on correct login, false otherwise
     * If true, must set $_SESSION['username'] = $username; at the end of the precess
     */
    public function doLogin(string $username, string $password): bool;
}

?>