/*
S-GAE (Simple Graphical Accounting Engine) is a web application developed at /rdlab to 
graphically display the accounting information generated by our HPC queue manager.

Copyright (C) +2020  rdlab@cs.upc.edu - https://rdlab.cs.upc.edu

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

$(function () {
	$("#error").hide()
	$("#success").hide()
	$("#hideError").click(function () {
		$("#error").hide()
	})
	$("#hideSuccess").click(function () {
		$("#success").hide()
	})
})

function display_error(error_msg) {
	$("#error").show()
	$("#error_msg").text(error_msg)
	window.scrollTo(0, 0);
}

function display_success(msg) {
	$("#success_msg").text(msg);
	$("#success").show()
	window.scrollTo(0, 0);
}

function ajax_success(data, textStatus, jqXHR) {
	try {
		var json = JSON.parse(data);
		if (json['status'] == "error") {
			display_error(json['error'])
		} else {
			display_success(json['msg'])
		}
	} catch (e) {
		display_error("An error has occurred")
		console.log(e)
	}
}

function ajax_error(jqXHR, textStatus, errorThrown) {
	display_error("Ajax error")
	console.log(jqXHR)
	console.log(textStatus)
	console.log(errorThrown)
}